summaryrefslogtreecommitdiff
path: root/arch/powerpc/tools/check-fpatchable-function-entry.sh
diff options
context:
space:
mode:
authorHari Bathini <hbathini@linux.ibm.com>2026-01-27 14:19:24 +0530
committerMadhavan Srinivasan <maddy@linux.ibm.com>2026-03-07 16:02:25 +0530
commit73cdf24e81e4eba52a40a6b10c6cf285d0ac23fd (patch)
treeaa4906f4d3e6c800b7e418fab36fb3cb012825f9 /arch/powerpc/tools/check-fpatchable-function-entry.sh
parent04e707cb77c272cb0bb2e2e3c5c7f844d804a089 (diff)
powerpc64: make clang cross-build friendly
ARCH_USING_PATCHABLE_FUNCTION_ENTRY depends on toolchain support for -fpatchable-function-entry option. The current script that checks for this support only handles GCC. Rename the script and extend it to detect support for -fpatchable-function-entry with Clang as well, allowing clean cross-compilation with Clang toolchains. Signed-off-by: Hari Bathini <hbathini@linux.ibm.com> Tested-by: Venkat Rao Bagalkote <venkat88@linux.ibm.com> Signed-off-by: Madhavan Srinivasan <maddy@linux.ibm.com> Link: https://patch.msgid.link/20260127084926.34497-2-hbathini@linux.ibm.com
Diffstat (limited to 'arch/powerpc/tools/check-fpatchable-function-entry.sh')
-rwxr-xr-xarch/powerpc/tools/check-fpatchable-function-entry.sh25
1 files changed, 25 insertions, 0 deletions
diff --git a/arch/powerpc/tools/check-fpatchable-function-entry.sh b/arch/powerpc/tools/check-fpatchable-function-entry.sh
new file mode 100755
index 000000000000..baed467a016b
--- /dev/null
+++ b/arch/powerpc/tools/check-fpatchable-function-entry.sh
@@ -0,0 +1,25 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0
+
+set -e
+
+# To debug, uncomment the following line
+# set -x
+
+# Output from -fpatchable-function-entry can only vary on ppc64 elfv2, so this
+# should not be invoked for other targets. Therefore we can pass in -m64 and
+# -mabi explicitly, to take care of toolchains defaulting to other targets.
+
+# Test whether the compile option -fpatchable-function-entry exists and
+# generates appropriate code
+echo "int func() { return 0; }" | \
+ $* -m64 -mabi=elfv2 -S -x c -O2 -fpatchable-function-entry=2 - -o - 2> /dev/null | \
+ grep -q "__patchable_function_entries"
+
+# Test whether nops are generated after the local entry point
+echo "int x; int func() { return x; }" | \
+ $* -m64 -mabi=elfv2 -S -x c -O2 -fpatchable-function-entry=2 - -o - 2> /dev/null | \
+ awk 'BEGIN { RS = ";" } /\.localentry.*nop.*\n[[:space:]]*nop/ { print $0 }' | \
+ grep -q "func:"
+
+exit 0